---
title: Logical properties for sizing
slug: Web/CSS/CSS_Logical_Properties/Sizing
tags:
  - CSS
  - CSS Logical Properties
  - Guide
  - sizing
  - writing modes
---
<div>{{CSSRef}}</div>

<p class="summary">In this guide we will explain the flow-relative mappings between physical dimension properties and logical properties used for sizing elements on our pages.</p>

<p>When specifying the size of an item, the <a href="https://drafts.csswg.org/css-logical/">Logical Properties and Values</a> specification gives you the ability to indicate sizing as it relates to the flow of text (inline and block) rather than physical sizing which relates to the physical dimensions of horizontal and vertical (e.g. left and right). While these flow relative mappings may well become the default for many of us, in a design you may well use both physical and logical sizing. You might want some features to always relate to the physical dimensions whatever the writing mode.</p>

<h2 id="Mappings_for_dimensions">Mappings for dimensions</h2>

<p>The table below provides mappings between logical and physical properties. These mappings assume that you are in a <code>horizontal-tb</code> writing mode, such as English or Arabic, in which case {{CSSxRef("width")}} would be mapped to {{CSSxRef("inline-size")}}.</p>

<p>If you were in a vertical writing mode then {{CSSxRef("inline-size")}} would be mapped to {{CSSxRef("height")}}.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Logical Property</th>
   <th scope="col">Physical Property</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{CSSxRef("inline-size")}}</td>
   <td>{{CSSxRef("width")}}</td>
  </tr>
  <tr>
   <td>{{CSSxRef("block-size")}}</td>
   <td>{{CSSxRef("height")}}</td>
  </tr>
  <tr>
   <td>{{CSSxRef("min-inline-size")}}</td>
   <td>{{CSSxRef("min-width")}}</td>
  </tr>
  <tr>
   <td>{{CSSxRef("min-block-size")}}</td>
   <td>{{CSSxRef("min-height")}}</td>
  </tr>
  <tr>
   <td>{{CSSxRef("max-inline-size")}}</td>
   <td>{{CSSxRef("max-width")}}</td>
  </tr>
  <tr>
   <td>{{CSSxRef("max-block-size")}}</td>
   <td>{{CSSxRef("max-height")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Width_and_height_example">Width and height example</h2>

<p>The logical mappings for {{CSSxRef("width")}} and {{CSSxRef("height")}} are {{CSSxRef("inline-size")}}, which sets the length in the inline dimension and {{CSSxRef("block-size")}}, which sets the length in the block dimension. When working in English, replacing <code>width</code> with <code>inline-size</code> and <code>height</code> with <code>block-size</code> will give the same layout.</p>

<p>In the live example below I have set the Writing Mode to <code>horizontal-tb</code>. Change it to <code>vertical-rl</code> and you will see that the first example — which uses <code>width</code> and <code>height</code> — remains the same size in each dimension, despite the text becoming vertical. The second example — which uses <code>inline-size</code> and <code>block-size</code> — will follow the text direction as if the entire block has rotated.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/size-inline-block.html", '100%', 500)}}</p>

<h2 id="Min-width_and_min-height_example">Min-width and min-height example</h2>

<p>There are also mappings for {{CSSxRef("min-width")}} and {{CSSxRef("min-height")}} — these are {{CSSxRef("min-inline-size")}} and {{CSSxRef("min-block-size")}}. These work in the same way as the <code>inline-size</code> and <code>block-size</code> properties, but setting a minimum rather than a fixed size.</p>

<p>Try changing the example below to <code>vertical-rl</code>, as with the first example, to see the effect it has. I am using <code>min-height</code> in the first example and <code>min-block-size</code> in the second.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/size-min.html", "100%", 500)}}</p>

<h2 id="Max-width_and_max-height_example">Max-width and max-height example</h2>

<p>Finally you can use {{CSSxRef("max-inline-size")}} and {{CSSxRef("max-block-size")}} as logical replacements for {{CSSxRef("max-width")}} and {{CSSxRef("max-height")}}. Try playing with the below example in the same way as before.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/size-max.html", "100%", 500)}}</p>

<h2 id="Logical_keywords_for_resize">Logical keywords for resize</h2>

<p>The {{CSSxRef("resize")}} property sets whether or not an item can be resized and has physical values of <code>horizontal</code> and <code>vertical</code>. The <code>resize</code> property also has logical keyword values. Using <code>resize: inline</code> allows resizing in the inline dimension and <code>resize: block</code> allow resizing in the block dimension.</p>

<p>The keyword value of <code>both</code> for the resize property works whether you are thinking physically or logically. It sets both dimensions at once. Try playing with the below example.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/size-resize.html", "100%", 700)}}</p>

<div class="notecard warning">
<p>Note that currently the logical values for resize are only supported by Firefox.</p>
</div>
